﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.31
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private BANano As BANano
	Private MyApp As VueApp
	Private navdrawer As VNavigationDrawer
	Private navmenu As VAppBarNavIcon
	Private listitem As VListItem
	Private snackbar As VSnackbar
	Private snackbarbutton As VBtn
	Private btnconfirmcancel As VBtn
	Private btnconfirmok As VBtn
	Private logo As VImg
End Sub

Sub Init
	'load the layout we will use
	BANano.LoadLayout("#body", "mashlayout")
	'initialize the vue instance, we will render it to #app element
	'we will .GetHTML from the #body
	MyApp.Initialize(Me, "#app", "#body")
	'add the snackbar
	BANano.LoadLayout("#placeholder", "snackbar")
	MyApp.BANanoGetHTML1("#placeholder", "#inspire")
	'add confirm dialog
	BANano.LoadLayout("#placeholder", "dialogconfirm")
	MyApp.BANanoGetHTML1("#placeholder", "#inspire")
	
	'define the items
	Dim items As List = BANanoShared.newlist
	items.add(CreateMap("key":"a", "icon":"mdi-clock","title":"Real-Time"))
	items.add(CreateMap("key":"b", "icon":"mdi-account","title":"Audience"))
	items.add(CreateMap("key":"c", "icon":"mdi-flag","title":"Conversations"))
	'save the state
	MyApp.SetData("items", items)
	'load the list icon title layout
	BANano.LoadLayout("#placeholder", "ListIconTitle")
	'append the layout to the drawer
	MyApp.BANanoGetHTML1("#placeholder", "#navdrawer")
	'
	'IMPORTANT - bind events and states
	navdrawer.AddToApp(MyApp)
	navmenu.AddToApp(MyApp)
	listitem.AddToApp(MyApp)
	snackbar.AddToApp(MyApp)
	snackbarbutton.AddToApp(MyApp)
	btnconfirmok.AddToApp(MyApp)
	btnconfirmcancel.AddToApp(MyApp)
	logo.AddToApp(MyApp)
	
	'show the logo
	MyApp.SetData("logoshow", True)
	'
	'add a spacer to the navbar
	MyApp.AddSpacer(Me, "navbar", "spacer1")
	
	'try and add multiple button icons
	Dim btnTest As VBtn = AddButton(Me, "navbar", "btnTest","Test Button", False, "mdi-plus", "red", "My button", "10", "green")
	btnTest.AddToApp(MyApp)
	'
	'serve the app
	MyApp.Serve
	
	'log the complete html for the page
	'Log(MyApp.Template)
End Sub

Sub AddButton(Module As Object, parentID As String, btnID As String, btnLabel As String, btnRaised As Boolean, btnIcon As String, iconColor As String, btnTooltip As String, btnBadge As String, badgeColor As String) As VBtn
	parentID = parentID.tolowercase
	btnID = btnID.tolowercase
	'
	'get the parent
	Dim Ret As Long
	Dim AllViews As Map
	
	'load button icon and clear the placeholder
	Ret = BANano.LoadLayoutArray("#placeholder", "buttonicon", True)
	' ret returns a unique number you can use to get all views
	AllViews = BANano.GetAllViewsFromLayoutArray(Module, "buttonicon", Ret)
	'get the tooltip title
	Dim buttontooltiptitle As VDiv = AllViews.Get("buttontooltiptitle")
	buttontooltiptitle.SetCaption(btnTooltip)
	'get the badge
	Dim buttonbadge As VBadge = AllViews.Get("buttonbadge")
	buttonbadge.SetContent(btnBadge)
	buttonbadge.SetColor(badgeColor)
	'get the button
	Dim button As VBtn = AllViews.get("button")
	If btnRaised = False Then button.SetText(True)
	button.SetOnClickE(btnID)
	button.SetOnClick
	'get the button label
	Dim buttontitle As VDiv = AllViews.Get("buttontitle")
	buttontitle.SetCaption(btnLabel)
	'get the icon
	Dim buttonicon As VIcon = AllViews.get("buttonicon")
	buttonicon.SetCaption(btnIcon)
	buttonicon.SetColor(iconColor)
	'
	Dim strx As String = MyApp.BANanoGetHTML("#placeholder")
	Log(strx)
	
	MyApp.BANanoEmpty("#placeholder")
	
	'MyApp.BANanoGetHTML1("#placeholder", parentID)
	'return the button
	Return button
End Sub


'when the navmenu is clicked
Sub navmenu_clickstop (event As BANanoEvent)
	navdrawer.toggle
End Sub

'when a drawer item is clicked
Sub listitem_click (argument As String)
	Select Case argument
		Case "a"
			MyApp.ShowSnackBarWarning(argument)
		Case "b"
			MyApp.ShowConfirmDialog(argument, "Confirm It", "Are you sure you want to...", "Yes", "No")
		Case "c"
			MyApp.ShowAlertDialog("Alert", "This is my alert!", "Yay!")
	End Select
End Sub

'snack bar button clicked
Sub SnackBarButton_click (argument As BANanoEvent)
	MyApp.HideSnackBar
End Sub

'ok  button clicked on the confirm dialog
Sub btnconfirmok_click (argument As BANanoEvent)
	Dim res As String = MyApp.GetConfirm
	MyApp.HideConfirm
	MyApp.ShowSnackBarSuccess(res)
End Sub

'cancel button clicked on the confirm dialog
Sub btnconfirmcancel_click (argument As BANanoEvent)
	MyApp.HideConfirm
End Sub

'a button is clicked in multi type button
Sub button_click (argument As Object)
	MyApp.ShowSnackBarSuccess(argument)
End Sub